--- dlls/comctl32/listview.c	2005-04-14 22:58:24.000000000 +0900
+++ dlls/comctl32/listview.c	2005-05-18 14:48:25.582221160 +0900
@@ -277,6 +277,7 @@
   INT nSearchParamLength;
   WCHAR szSearchParam[ MAX_PATH ];
   BOOL bIsDrawing;
+  INT nMeasureItemHeight;
 } LISTVIEW_INFO;
 
 /*
@@ -2422,6 +2423,8 @@
 	    nItemHeight = max(nItemHeight, infoPtr->iconSize.cy);
 	if (infoPtr->himlState || infoPtr->himlSmall)
 	    nItemHeight += HEIGHT_PADDING;
+    if (infoPtr->nMeasureItemHeight > 0)
+        nItemHeight = infoPtr->nMeasureItemHeight;
     }
 
     return max(nItemHeight, 1);
@@ -7425,6 +7428,7 @@
   infoPtr->iconSpacing.cy = GetSystemMetrics(SM_CYICONSPACING);
   infoPtr->nEditLabelItem = -1;
   infoPtr->dwHoverTime = -1; /* default system hover time */
+  infoPtr->nMeasureItemHeight = 0;
 
   /* get default font (icon title) */
   SystemParametersInfoW(SPI_GETICONTITLELOGFONT, 0, &logFont, 0);
@@ -9286,8 +9290,24 @@
   case WM_WINDOWPOSCHANGED:
       if (!(((WINDOWPOS *)lParam)->flags & SWP_NOSIZE)) 
       {
+      UINT uView = infoPtr->dwStyle & LVS_TYPEMASK;
 	  SetWindowPos(infoPtr->hwndSelf, 0, 0, 0, 0, 0, SWP_FRAMECHANGED | SWP_NOACTIVATE |
 		       SWP_NOZORDER | SWP_NOMOVE | SWP_NOSIZE);
+
+      if ((infoPtr->dwStyle & LVS_OWNERDRAWFIXED) && (uView == LVS_REPORT))
+      {
+          MEASUREITEMSTRUCT mis;
+          mis.CtlType = ODT_LISTVIEW;
+          mis.CtlID = GetWindowLongPtrW(infoPtr->hwndSelf, GWLP_ID);
+          mis.itemID = -1;
+          mis.itemWidth = 0;
+          mis.itemData = 0;
+          mis.itemHeight= infoPtr->nItemHeight;
+          SendMessageW(infoPtr->hwndNotify, WM_MEASUREITEM, mis.CtlID, (LPARAM)&mis);
+          if (infoPtr->nItemHeight != max(mis.itemHeight, 1))
+              infoPtr->nMeasureItemHeight = infoPtr->nItemHeight = max(mis.itemHeight, 1);
+      }
+
 	  LISTVIEW_UpdateSize(infoPtr);
 	  LISTVIEW_UpdateScroll(infoPtr);
       }
